const dashboard = {
    state () {
        return {
            Budgets: [],
            CurrentBudget: null,
        }
    },
    mutations: {
        setBudgets (state, budgets) {
            state.Budgets = budgets;
        },
        addBudget(state, budget) {
            state.Budgets.push(budget);
        }
    },
    getters: {
        Budgets(state) {
            return state.Budgets || [];
        }
    },
    actions: {
        fetchDashboard ({state, commit, rootState}) {
            fetch("/api/v1/dashboard", {
                headers: {
                    'Authorization': 'Bearer ' + rootState.Session.Token
                }
            })
                .then(x => x.json())
                .then(x => commit("setBudgets", x.Budgets));
        },
        newBudget ({state, commit, rootState}, budgetName) {
            fetch("/api/v1/budget/new", {
                method: "POST",
                body: JSON.stringify({name: budgetName}),
                headers: {
                    'Authorization': 'Bearer ' + rootState.Session.Token
                }
            })
                .then(x => x.json())
                .then(x => commit("addBudget", x));
        }
    }
}

export default dashboard